'SSP extractor
'by K1n9_Duk3

Framework BRL.system
SuperStrict

Local infile$ = RequestFile("Open STORM1.SSP")
If infile
	Local in:TStream = ReadFile(infile)
	Local numfiles:Short = ReadShort(in)
	Local sizes:Int[128]
	Local names:String[130]
	Local offsets:Int[161]
	
	For Local i:Int = 0 Until 128
		sizes[i] = ReadInt(in)
	Next
	For Local i:Int = 0 Until 130
		Local buffer:Byte[65]
		in.ReadBytes(buffer, 64)
		buffer[64] = 0
		names[i] = String.FromCString(buffer)
	Next
	For Local i:Int = 0 Until 161
		offsets[i] = ReadInt(in)
	Next
	
	Local badoffset:Byte=False
	For Local i:Int = 0 Until numfiles
		'Print names[i]+": "+sizes[i]+" bytes at "+offsets[i]
		If i > 0 And offsets[i] <> offsets[i-1]+sizes[i-1]
			'Print "bad offset"
			badoffset = True
		EndIf
	Next
	
	If Not badoffset
		Local outpath$ = RequestDir("Select folder to extract files to...")
		If outpath
			For Local i:Int = 0 Until numfiles
				Local out:TStream = WriteFile(outpath+"/"+names[i])
				If out
					CopyBytes(in, out, sizes[i])
					CloseFile(out)
				EndIf
			Next
		EndIf
	EndIf
EndIf
